import { useRef } from 'react';
import { useLoad, useUnload, useAppActive, useAppInactive, } from 'react-native-lifecycle';
export default (effect, ms, options = {}) => {
    const { active = true } = options;
    const i = useRef(null);
    const appActive = useRef(true);
    const isActive = useRef(active);
    useAppActive(() => {
        appActive.current = true;
    });
    useAppInactive(() => {
        appActive.current = false;
    });
    useLoad(() => {
        i.current = setInterval(() => {
            if (appActive.current && isActive.current) {
                effect();
            }
        }, ms);
    });
    useUnload(() => {
        if (i.current) {
            clearInterval(i.current);
        }
    });
    const setActive = (active) => {
        isActive.current = active;
    };
    return {
        setActive,
    };
};
