import { Platform } from 'react-native';
import { checkMultiple, requestMultiple, RESULTS, openSettings, } from 'react-native-permissions';
/**
 * @param permissions
 * @param permissionStatus
 */
const request = (permissions, permissionStatus = RESULTS.GRANTED) => {
    return new Promise((resolve, reject) => {
        permissions.filter((item) => item && item.startsWith(Platform.OS));
        checkMultiple(permissions).then(checkMultipleStates => {
            permissions = permissions.filter(permission => checkMultipleStates[permission] !== permissionStatus);
            if (permissions.length === 0) {
                resolve();
            }
            else {
                requestMultiple(permissions).then(requestMultipleStates => {
                    permissions = permissions.filter(permission => requestMultipleStates[permission] !== permissionStatus);
                    if (permissions.length === 0) {
                        resolve();
                    }
                    else {
                        reject({
                            openSettings,
                        });
                    }
                });
            }
        });
    });
};
export default {
    request,
};
